/* ET-Beispiel-Unterprogramm: (C) 1990/Jan/06 - 1991/Okt/13,	*/
/*			       R. Scharnagl, 4000 Duesseldorf 1 */

  /*============================================================*/
  /* UPRO.T - Demonstrations-Unterprogramm zur Benutzung von	*/
  /* Entscheidungstabellen (ETs) in C-Programmen mittels des	*/
  /* Precompilers DTT.						*/
  /*============================================================*/

#ifdef __STDC__
#include <stdlib.h>
#define _(parms) parms /* prototyp */
#else
#define void  /* */
#define const /* */
#define _(parms) ()    /* old declaration */
#endif

/* Benoetigte Copy-Bibliothek */
#include <stdio.h>

#ifdef __TURBOC__
#pragma warn -use
#endif

/* Prototypen */
extern void Outc    _((char c));
extern void Ausgabe _((int i));

void Outc(char c)	/*======================================*/
			/* Ausgabe eines Zeichens auf CON:	*/
{			/*======================================*/

  $TABLE ZeichenausgabeStdOut		     /* AKTIONS-TABELLE */
  /*------------------------------------------------------------*/
     putchar(c);		  /* einzelnes Zeichen ausgeben */
  $END
}

void Ausgabe(int m)	       /*===============================*/
			       /* Ausgabe einer 5er-Dezimalzahl */
{			       /*===============================*/

  int dig[6],i,c;

  $TABLE Start_Ausgabe		       /* REINE AKTIONS-TABELLE */
  /*------------------------------------------------------------*/
     c = 5;					  /* Feldbreite */
     i = 0;					     /* Zaehler */
  $END

  $TABLE Z_Puffern	       /* ET MIT 2 REGELN UND VORAKTION */
  /*------------------------------------------------------------*/
     dig[i] = m % 10;			  /* ermittle 10er-Rest */
  $C ((m /= 10) != 0)		 /* noch fuehrende Stellen da ? */  $ Y N
  $A ++i;				       /* zaehle Ziffer */  $ X .
     goto $T;		   /* $T-Makro: wiederhole die ganze ET */  $ X .
  $END

  $TABLE Leerzeichen	   /* ET MIT 2 REGELN UND SCHLEIFENKOPF */
  /*------------------------------------------------------------*/
     for (; ; ) 		 /* potentielle Endlos-Schleife */
  $C if (--c > i)		       /* fehlen noch Ziffern ? */  $ N Y
  $A Outc(' '); 		  /* gib dafuer Leerzeichen aus */  $ . X
     break;			       /* verlasse die Schleife */  $ X .
  $END

  $TABLE Ziffern			     /* ET MIT 2 REGELN */
  /*------------------------------------------------------------*/
  $C (i >= 0)		     /* sind noch Ziffern gespeichert ? */  $ N Y
  $A Outc('0'+dig[i]);			  /* gib die Ziffer aus */  $ . X
     --i;				   /* und zaehle sie ab */  $ . X
     goto $C;		/* $C-Makro: springe erneut zum $C-Teil */  $ . X
  $END
}

